jjb: Extend version range of genheaders patch to cover v4.18.16-rt9-rebase
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
1 #!/bin/bash
2 #
3 # Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see <http://www.gnu.org/licenses/>.
17
18 set -exu
19
20 # Parameters
21 platforms=${platforms:-}
22 # Derive arch from label if it isn't set
23 if [ -z "${arch:-}" ] ; then
24 # Labels may be platform specific, eg. jammy-amd64, deb12-armhf
25 regex='[[:alnum:]]+-([[:alnum:]]+)'
26 if [[ "${platforms}" =~ ${regex} ]] ; then
27 arch="${BASH_REMATCH[1]}"
28 else
29 arch="${platforms:-}"
30 fi
31 fi
32
33 cross_arch=${cross_arch:-}
34 ktag=${ktag:-}
35 kgitrepo=${kgitrepo:-}
36 mversion=${mversion:-}
37 mgitrepo=${mgitrepo:-}
38 make_args=()
39
40 DEBUG=${DEBUG:-}
41
42 ## FUNCTIONS ##
43
44 # Kernel version compare functions
45 verlte() {
46 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
47 }
48
49 verlt() {
50 # shellcheck disable=SC2015
51 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
52 }
53
54 vergte() {
55 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
56 }
57
58 vergt() {
59 # shellcheck disable=SC2015
60 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
61 }
62
63 git_clone_modules_sources() {
64 mkdir -p "$MODULES_GIT_DIR"
65
66 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
67 # as a branch name.
68 if [ "${mversion:0:5}" = "refs/" ]; then
69 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
70 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
71 else
72 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
73 fi
74 }
75
76 # Checkout a shallow kernel tree of the specified tag
77 git_clone_linux_sources() {
78 mkdir -p "$LINUX_GIT_DIR"
79 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
80 }
81
82
83 # Export the kernel sources from the git repo
84 git_export_linux_sources() {
85 cd "$LINUX_GIT_DIR"
86 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
87 }
88
89
90 # Upload the tar archive to the object store
91 upload_archive_obj() {
92 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
93 rm -f "$WORKSPACE/$obj_name"
94 }
95
96
97 extract_archive_obj() {
98 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR" -I pbzip2
99 rm -f "$WORKSPACE/$obj_name"
100 }
101
102
103 tar_archive_obj() {
104 cd "$LINUX_OBJ_DIR"
105 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
106 cd -
107 }
108
109 list_gccs() {
110 local gccs
111 gccs=()
112 IFS=: read -r -a path_array <<< "$PATH"
113 while read -r gcc ; do
114 gccs+=("$gcc")
115 done < <(find "${path_array[@]}" -maxdepth 1 -regex '.*/gcc-[0-9\.]+$' -printf '%f\n' | sort -t- -k2 -V -r)
116 echo "${gccs[@]}"
117 }
118
119 # Find the most recent GCC version supported by the kernel sources
120 select_compiler() {
121 local selected_cc
122
123 cd "$LINUX_SRCOBJ_DIR"
124
125 kversion=$(make -s kernelversion)
126
127 set +e
128
129 for cc in $(list_gccs) ; do
130 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
131 cc_version=$(echo "${cc}" | cut -d'-' -f2)
132 if { verlt "${kversion}" "5.17"; } && { vergt "${cc_version}" "11"; } ; then
133 # Using gcc-12+ with '-Wuse-after-free' breaks the build of older
134 # kernels (in particular, objtool). Some releases on LTS
135 # branches between 4.x and 5.15 can be built with gcc-12.
136 # @see https://lore.kernel.org/lkml/20494.1643237814@turing-police/
137 # @see https://gitlab.com/linux-kernel/stable/-/commit/52a9dab6d892763b2a8334a568bd4e2c1a6fde66
138 continue
139 fi
140 selected_cc="$cc"
141 break
142 fi
143 done
144
145 set -e
146
147 # Force gcc-4.8 for kernels before 4.4
148 if { verlt "$kversion" "4.4"; }; then
149 selected_cc='gcc-4.8'
150 fi
151
152 if [ "x$selected_cc" = "x" ]; then
153 echo "Found no suitable compiler."
154 exit 1
155 fi
156
157 _KAFLAGS=()
158 _KCFLAGS=()
159 _KCPPFLAGS=()
160 _HOSTCFLAGS=()
161 if [ "$selected_cc" != "gcc-4.8" ]; then
162 # Older kernel Makefiles do not expect the compiler to default to PIE
163 _KAFLAGS+=(-fno-pie)
164 _KCFLAGS+=(
165 -fno-pie
166 -no-pie
167 -fno-stack-protector
168 )
169 _KCPPFLAGS+=(-fno-pie)
170 fi
171
172 selected_cc_version="$(echo "${selected_cc}" | cut -d'-' -f2)"
173 if { vergte "${selected_cc_version}" "10"; } && { verlt "${kversion}" "5.10"; } ; then
174 # gcc-10 changed the default from '-fcommon' to '-fno-common', which
175 # causes a linker failure. '-fcommon' can be set on the HOSTCFLAGS
176 # to avoid the issue.
177 # @see https://gitlab.com/linux-kernel/stable/-/commit/e33a814e772cdc36436c8c188d8c42d019fda639
178 _HOSTCFLAGS+=(-fcommon)
179 fi
180
181 if [ "${cross_arch:-}" == "armhf" ] ; then
182 if { verlt "${kversion}" "5.14"; } ; then
183 # Work-around for producing instructions that aren't valid for the
184 # default architectures.
185 # Eg. Error: selected processor does not support `cpsid i' in ARM mode
186 _KCFLAGS+=(-march=armv7-a -mfpu=vfpv3-d16)
187 _KCPPFLAGS+=(-march=armv7-a -mfpu=vfpv3-d16)
188 fi
189 fi
190
191 if { vergt "${selected_cc_version}" "8"; } && { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ; then
192 # This was added to -Wall in gcc 9 but some kernels do not include the fixes
193 # @see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=88583
194 _KCFLAGS+=(-Wno-error=packed-not-aligned)
195 fi
196
197 export KAFLAGS="${_KAFLAGS[*]}"
198 export KCFLAGS="${_KCFLAGS[*]}"
199 export KCPPFLAGS="${_KCPPFLAGS[*]}"
200 export HOSTCFLAGS="${_HOSTCFLAGS[*]}"
201 export CC="${CROSS_COMPILE:-}${selected_cc}"
202 export HOSTCC="${selected_cc}"
203
204 make_args=(
205 CC="${CC}"
206 HOSTCC="${HOSTCC}"
207 HOSTCFLAGS="${HOSTCFLAGS:-}"
208 )
209 if [ -n "${DEBUG}" ] ; then
210 make_args+=(
211 V=1
212 )
213 fi
214 cd -
215 }
216
217 patch_linux_kernel() {
218 local commit_hash
219 commit_hash="$1"
220 set +e
221 git -C "${LINUX_GIT_REF_REPO_DIR}" format-patch -n1 --stdout "${commit_hash}" | patch -p1
222 set -e
223 if [ "$?" -gt 1 ] ; then
224 echo "Serious issue patching"
225 exit 1
226 fi
227 }
228
229 build_linux_kernel() {
230 cd "$LINUX_SRCOBJ_DIR"
231
232 kversion=$(make -s kernelversion "${make_args[@]}")
233 pahole_version="$(pahole --version | tr -d 'v')"
234
235 if { verlt "${kversion}" "3.3"; } && [ "${vanilla_config}" = "imx_v6_v7_defconfig" ] ; then
236 # imx_v6_v7 didn't exist before 06965c39b4c63933fa0a1cde2237ef85477c5655
237 if { verlt "${kversion}" "3.2"; } ; then
238 vanilla_config='mx5_defconfig'
239 else
240 vanilla_config='mx51_defconfig'
241 fi
242 fi
243
244 if { verlt "${kversion}" "3.13"; } && [ "${vanilla_config}" = "pseries_le_defconfig" ] ; then
245 # pseries_le_deconfig was introduced in f53e462e907cbaed29c49c0f10f5b8f614e1bf1d
246 vanilla_config='pseries_defconfig'
247 fi
248
249 # Generate kernel configuration
250 case "$ktag" in
251 Ubuntu*)
252 if [ "${cross_arch}" = "powerpc" ]; then
253 if vergte "${kversion}" "4.10"; then
254 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
255 exit 0
256 fi
257 fi
258
259 # Disable riscv64 config generation, we don't have a toolchain on bionic
260 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
261
262 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
263
264 # Hack for kernel Ubuntu-hwe-5.8
265 # The debian/control file is produced by the clean target above, so this
266 # check needs to happen afterwards.
267 if [ ! -f "debian/compat" ] && ! grep -q debhelper-compat debian/control; then
268 echo "10" > "debian/compat"
269 fi
270
271 # genconfigs check can fail in certain cases, eg. when a more recent
272 # compiler exposes kernel configuration flags which aren't set in the
273 # Ubuntu annotations.
274 # In any case, the configuration will be updated with any missing values
275 # later in our build script.
276 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=. do_skip_checks=true
277 cp CONFIGS/"${ubuntu_config}" .config
278 ;;
279
280 *)
281 # Force 32bit build on i386, default is 64bit
282 if [ "$arch" = "i386" ]; then
283 export ARCH="i386"
284 fi
285
286 make "${vanilla_config}" "${make_args[@]}"
287 ;;
288 esac
289
290 if [ "${vanilla_config}" = "pseries_defconfig" ] && [ "${cross_arch}" = "ppc64el" ] ; then
291 # @see diff <(git show v3.13:arch/powerpc/configs/pseries_defconfig) <(git show v3.13:arch/powerpc/configs/pseries_le_defconfig)
292 scripts/config --enable CONFIG_CPU_LITTLE_ENDIAN
293 scripts/config --enable CONFIG_CMA
294 scripts/config --disable CONFIG_XMON_DEFAULT
295 # scripts/config --disable CONFIG_VIRTUALIZATION
296 # scripts/config --disable CONFIG_KVM_BOOK3S_64
297 scripts/config --disable CONFIG_KVM_BOOK3S_64_HV
298 fi
299
300 # oldnoconfig was renamed in 4.19
301 if vergte "$kversion" "4.19"; then
302 update_conf_target="olddefconfig"
303 else
304 update_conf_target="oldnoconfig"
305 fi
306
307 # Fix 'defined(@array)' was removed from recent perl
308 if [ -f "kernel/timeconst.pl" ]; then
309 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
310 fi
311
312 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
313 if [ "$HOSTCC" != "gcc-4.8" ]; then
314 if [ -f "arch/x86/kvm/svm.c" ]; then
315 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
316 fi
317
318 if [ -f "arch/x86/kvm/vmx.c" ]; then
319 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
320 fi
321 fi
322
323 if { verlt "${kversion}" "5.11"; } && { vergte "${kversion}" "4.10"; } ; then
324 # Binutils > 2.35 strips empty symbol tables, causing obltool to fail
325 # in certain cases when files are empty.
326 # @see https://gitlab.com/linux-kernel/stable/-/commit/1d489151e9f9d1647110277ff77282fe4d96d09b
327 #
328 # There doesn't seem to be any LD/AS/AR flags to control this behaviour,
329 # therefore patching tools/objtool/elf.c is attempted.
330 patch_linux_kernel 1d489151e9f9d1647110277ff77282fe4d96d09b
331 if { verlt "${kversion}" "4.18"; } ; then
332 patch_linux_kernel e81e0724432542af8d8c702c31e9d82f57b1ff31
333 fi
334 fi
335
336 if { vergt "${selected_cc_version}" "7"; } && { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ; then
337 # Builds fail due to -Werror=restrict in pager.o and str_error_r.o
338 if { verlt "${kversion}" "4.16"; } ; then
339 # This is patched since objtool's Makefile doesn't respect HOSTCFLAGS
340 # @see https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=ad343a98e74e85aa91d844310e797f96fee6983b
341 patch_linux_kernel ad343a98e74e85aa91d844310e797f96fee6983b
342 fi
343 if { verlt "${kversion}" "4.17"; } ; then
344 # This is patched since objtool's Makefile doesn't respect HOSTCFLAGS
345 # @see https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=854e55ad289ef8888e7991f0ada85d5846f5afb9
346 patch_linux_kernel 854e55ad289ef8888e7991f0ada85d5846f5afb9
347 fi
348
349 # More recent compiler optimizations expose build errors with netronome.
350 # It seems easier to disable the driver than to attempt patching.
351 scripts/config --disable CONFIG_NET_VENDOR_NETRONOME
352 scripts/config --disable CONFIG_MICREL_PHY
353
354 # Duplicate decalarations of __force_order
355 # @see https://gitlab.com/linux-kernel/stable/-/commit/df6d4f9db79c1a5d6f48b59db35ccd1e9ff9adfc
356 # However, kaslr_64.c doesn't exit in 4.15, 4.16, it's named pagetable.c
357 if [ -f arch/x86/boot/compressed/pagetable.c ] ; then
358 sed -i '/^unsigned long __force_order;$/d' arch/x86/boot/compressed/pagetable.c
359 fi
360 fi
361
362 if { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.18"; } ; then
363 # Some old kernels fail to build when make is too new
364 # @see https://gitlab.com/linux-kernel/stable/-/commit/9feeb638cde083c737e295c0547f1b4f28e99583
365 patch_linux_kernel 9564a8cf422d7b58f6e857e3546d346fa970191e
366 # @see https://gitlab.com/linux-kernel/stable/-/commit/9feeb638cde083c737e295c0547f1b4f28e99583
367 patch_linux_kernel 9feeb638cde083c737e295c0547f1b4f28e99583
368 fi
369
370 if { vergte "${kversion}" "4.12"; } && { verlt "${kversion}" "4.19"; } ; then
371 # Old kernels can fail to build while on newer host kernels with errors
372 # such as:
373 # In file included from scripts/selinux/genheaders/genheaders.c:19:
374 # ./security/selinux/include/classmap.h:249:2: error: #error New address family defined, please update secclass_map.
375 # @see https://gitlab.com/linux-kernel/stable/-/commit/dfbd199a7cfe3e3cd8531e1353cdbd7175bfbc5e
376 #
377 patch_linux_kernel dfbd199a7cfe3e3cd8531e1353cdbd7175bfbc5e
378 fi
379
380 if { vergte "${kversion}" "3.18"; } && { verlt "${kversion}" "4.4"; } ; then
381 # Compatibility with binutils >= ~ 2.31
382 patch_linux_kernel b21ebf2fb4cde1618915a97cc773e287ff49173e
383 fi
384
385 # The above patch only partially applies linux 3.17, and has been, so a
386 # rebased version is used instead.
387 if { vergte "${kversion}" "3.17"; } && { verlt "${kversion}" "3.18"; } ; then
388 cat <<'EOF' | patch -p1
389 diff --git a/arch/x86/kernel/machine_kexec_64.c b/arch/x86/kernel/machine_kexec_64.c
390 index 48598105..0652c5b6 100644
391 --- a/arch/x86/kernel/machine_kexec_64.c
392 +++ b/arch/x86/kernel/machine_kexec_64.c
393 @@ -516,6 +516,7 @@ int arch_kexec_apply_relocations_add(const Elf64_Ehdr *ehdr,
394 goto overflow;
395 break;
396 case R_X86_64_PC32:
397 + case R_X86_64_PLT32:
398 value -= (u64)address;
399 *(u32 *)location = value;
400 break;
401 diff --git a/arch/x86/kernel/module.c b/arch/x86/kernel/module.c
402 index e69f9882..7c6bc9fe 100644
403 --- a/arch/x86/kernel/module.c
404 +++ b/arch/x86/kernel/module.c
405 @@ -180,6 +180,7 @@ int apply_relocate_add(Elf64_Shdr *sechdrs,
406 goto overflow;
407 break;
408 case R_X86_64_PC32:
409 + case R_X86_64_PLT32:
410 val -= (u64)loc;
411 *(u32 *)loc = val;
412 #if 0
413 diff --git a/arch/x86/tools/relocs.c b/arch/x86/tools/relocs.c
414 index bbb1d225..8deeacbc 100644
415 --- a/arch/x86/tools/relocs.c
416 +++ b/arch/x86/tools/relocs.c
417 @@ -763,6 +763,7 @@ static int do_reloc64(struct section *sec, Elf_Rel *rel, ElfW(Sym) *sym,
418 switch (r_type) {
419 case R_X86_64_NONE:
420 case R_X86_64_PC32:
421 + case R_X86_64_PLT32:
422 /*
423 * NONE can be ignored and PC relative relocations don't
424 * need to be adjusted.
425 EOF
426 fi
427
428 if ( { vergte "${kversion}" "3.15"; } && { verlt "${kversion}" "4.4"; } ) ||
429 ( { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ); then
430 # While the original motivation of this patch is for fixing builds using
431 # clang, the same error occurs between linux >= 3.15 and < 4.4, and in
432 # 4.15, 4.16.
433 #
434 # This patch only partially applies due to changes in kernel/Makefile,
435 # so a supplementary patch is needed
436 #
437 # Without this patch, builds fail with
438 # Cannot find symbol for section 2: .text.
439 # kernel/elfcore.o: failed
440 #
441 # @see https://github.com/linuxppc/issues/issues/388
442 # @see https://lore.kernel.org/lkml/20201204165742.3815221-2-arnd@kernel.org/
443 #
444 patch_linux_kernel 6e7b64b9dd6d96537d816ea07ec26b7dedd397b9
445 if grep -q elfcore.o kernel/Makefile ; then
446 sed -i '/^.* += elfcore.o$/d' kernel/Makefile
447 fi
448 fi
449
450 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
451 # Convert them to 'cmpw' which was previously done silently
452 if verlt "$kversion" "4.9"; then
453 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
454 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
455 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
456 fi
457
458 # Fix a typo in v2.6.36.x
459 if [ -f "arch/x86/kernel/entry_64.S" ]; then
460 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
461 fi
462
463 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
464 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
465 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
466 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
467 fi
468
469 # Fix kernel < 3.0 with gcc >= 4.7
470 if verlt "$kversion" "3.0"; then
471 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
472 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
473 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
474 echo "header-y += linkage.h" >> include/linux/Kbuild
475 fi
476
477 if [ "${cross_arch}" = "powerpc" ] ; then
478 if { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.16"; } ; then
479 # Avoid register errors such as
480 # aes_generic.c:(.text+0x4e0): undefined reference to `_restgpr_31_x'
481 # @see https://gitlab.com/linux-kernel/stable/-/commit/148b974deea927f5dbb6c468af2707b488bfa2de
482 make_args+=(
483 CFLAGS_aes_generic.o=''
484 )
485 fi
486 fi
487
488 if [ "$(scripts/config --state CONFIG_DEBUG_INFO_BTF)" == "y" ] &&
489 { vergte "${pahole_version}" "1.24"; } &&
490 { vergte "${kversion}" "5.10"; } && { verlt "${kversion}" "6.0"; } ;then
491 # Some kernels Eg. Ubuntu-hwe-5.13-5.13.0-52.59_20.04.1
492 # fail with the following error:
493 # BTFIDS vmlinux
494 # FAILED: load BTF from vmlinux: Invalid argument
495 #
496 # When CONFIG_DEBUG_INFO_BTF is set, certain versions of pahole require
497 # `--skip_encoding_btf_enum64` to be passed as the kernel doesn't define
498 # BTF_KIND_ENUM64.
499 #
500 # Introduced in 341dfcf8d78eaa3a2dc96dea06f0392eb2978364 (~v5.10)
501 # @see https://lore.kernel.org/bpf/20220825171620.cioobudss6ovyrkc@altlinux.org/t/
502 #
503 if [ -f "scripts/pahole-flags.sh" ] ; then
504 sed -i 's/ -J ${PAHOLE_FLAGS} / -J ${PAHOLE_FLAGS} --skip_encoding_btf_enum64 /' scripts/link-vmlinux.sh
505 else
506 sed -i 's/ -J ${extra_paholeopt} / -J ${extra_paholeopt} --skip_encoding_btf_enum64 /' scripts/link-vmlinux.sh
507 fi
508 fi
509
510 # GCC 4.8
511 if [ "$HOSTCC" == "gcc-4.8" ]; then
512 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
513 scripts/config --disable CONFIG_PPC_OF_BOOT_TRAMPOLINE
514 fi
515
516 # Don't try to sign modules
517 scripts/config --disable CONFIG_MODULE_SIG
518
519 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
520 scripts/config --disable CONFIG_STACK_VALIDATION
521
522 # Cause problems with inline assembly on i386
523 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
524
525 # Don't build samples, they are broken on some kernel releases
526 scripts/config --disable CONFIG_SAMPLES
527 scripts/config --disable CONFIG_BUILD_DOCSRC
528
529 # Disable kcov
530 scripts/config --disable CONFIG_KCOV
531
532 # Broken on some RT kernels
533 scripts/config --disable CONFIG_HYPERV
534
535 # Broken drivers
536 scripts/config --disable CONFIG_RAPIDIO_TSI721
537 scripts/config --disable CONFIG_SGI_XP
538 scripts/config --disable CONFIG_MFD_WM8994
539 scripts/config --disable CONFIG_DRM_RADEON
540 scripts/config --disable CONFIG_SND_SOC_WM5100
541
542 # IGBVF won't build with recent gcc on 2.6.38.x
543 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
544 scripts/config --disable CONFIG_IGBVF
545 fi
546
547 # Don't fail the build on warnings
548 scripts/config --disable CONFIG_WERROR
549 scripts/config --enable CONFIG_PPC_DISABLE_WERROR
550
551 # Set required options
552 scripts/config --enable CONFIG_TRACEPOINTS
553 scripts/config --enable CONFIG_KALLSYMS
554 scripts/config --enable CONFIG_HIGH_RES_TIMERS
555 scripts/config --enable CONFIG_KPROBES
556 scripts/config --enable CONFIG_FTRACE
557 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
558 scripts/config --enable CONFIG_KALLSYMS_ALL
559 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
560 scripts/config --enable CONFIG_PERF_EVENTS
561 scripts/config --enable CONFIG_EVENT_TRACING
562 scripts/config --enable CONFIG_KRETPROBES
563
564 if [ -n "${DEBUG}" ] ; then
565 cat .config
566 fi
567
568 make "$update_conf_target" "${make_args[@]}"
569 make -j"$NPROC" "${make_args[@]}"
570
571 krelease=$(make -s kernelrelease "${make_args[@]}")
572
573 # Save the kernel and modules
574 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
575 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install "${make_args[@]}"
576 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install "${make_args[@]}"
577 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
578 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
579 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
580 }
581
582
583 extract_distro_headers() {
584
585 # Enter linux source dir
586 cd "${LINUX_SRCOBJ_DIR}"
587
588
589 # For RT kernels, copy version file
590 if [ -s localversion-rt ]; then
591 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
592 fi
593
594 # Copy all Makefile related stuff
595 find . -path './include/*' -prune \
596 -o -path './scripts/*' -prune -o -type f \
597 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
598 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
599 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
600
601 # Copy base scripts and include dirs
602 cp -a scripts include "${LINUX_HDROBJ_DIR}"
603
604 # Copy arch includes
605 (find arch -name include -type d -print0 | \
606 xargs -0 -n1 -i: find : -type f) | \
607 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
608
609 # Copy arch scripts
610 (find arch -name scripts -type d -print0 | \
611 xargs -0 -n1 -i: find : -type f) | \
612 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
613
614 # Cleanup scripts
615 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
616 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
617
618 # On powerpc 32bits this object is required to link modules
619 if [ "${karch}" = "powerpc" ]; then
620 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
621 :
622 else
623 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
624 fi
625 fi
626
627 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
628 if [ "${karch}" = "arm64" ]; then
629 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
630 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
631 fi
632 fi
633
634 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
635 if [ -f tools/objtool/objtool ]; then
636 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
637 fi
638
639 if [ -f "arch/x86/kernel/macros.s" ]; then
640 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
641 fi
642
643 # Copy modules related stuff, if available
644 if [ -s Module.symvers ]; then
645 cp Module.symvers "${LINUX_HDROBJ_DIR}"
646 fi
647
648 if [ -s System.map ]; then
649 cp System.map "${LINUX_HDROBJ_DIR}"
650 fi
651
652 if [ -s Module.markers ]; then
653 cp Module.markers "${LINUX_HDROBJ_DIR}"
654 fi
655
656 # Copy config file
657 cp .config "${LINUX_HDROBJ_DIR}"
658
659 # Make sure the Makefile and version.h have a matching timestamp so that
660 # external modules can be built
661 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
662 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
663 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
664 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
665 else
666 echo "Missing version.h"
667 exit 1
668 fi
669 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
670
671 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
672 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
673 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
674 fi
675
676 # Finally clean the object files from the full source tree
677 make clean
678
679 # And regen the modules support files
680 make modules_prepare "${make_args[@]}"
681
682 # On powerpc 32bits this object is required to link modules
683 if [ "${karch}" = "powerpc" ]; then
684 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
685 :
686 else
687 make arch/powerpc/lib/crtsavres.o "${make_args[@]}"
688 fi
689 fi
690
691 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
692 if [ "${karch}" = "arm64" ]; then
693 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
694 make arch/arm64/kernel/ftrace-mod.o "${make_args[@]}"
695 fi
696 fi
697
698 # Version specific tasks
699 case "$ktag" in
700 Ubuntu*)
701 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
702 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
703 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
704 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
705 ;;
706 esac
707 }
708
709
710 build_modules() {
711
712 local kdir="$1"
713 local outdir="$2"
714 local kversion
715
716 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
717
718 # Try to catch some compatibility problems by turning some
719 # warnings into errors.
720 #export KCFLAGS="$KCFLAGS -Wall -Werror"
721
722 # Enter lttng-modules source dir
723 cd "${MODULES_GIT_DIR}"
724
725 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
726 # timekeeping subsystem. We want those build to fail.
727 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
728 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
729
730 set +e
731
732 # Build modules
733 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 "${make_args[@]}"
734 ret=$?
735
736 set -e
737
738 # We expect this build to fail, if it doesn't, fail the job.
739 if [ "$ret" -eq 0 ]; then
740 echo "This build should have failed."
741 exit 1
742 fi
743
744 # We have to publish at least one file or the build will fail
745 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
746
747 KERNELDIR="${kdir}" make clean
748
749 else # Regular build
750
751 # Build modules against full kernel sources
752 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 "${make_args[@]}"
753
754 # Install modules to build dir
755 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
756
757 # Clean build dir
758 KERNELDIR="${kdir}" make clean
759 fi
760 }
761
762
763 ## MAIN ##
764
765 # Use all CPU cores
766 NPROC=$(nproc)
767
768 MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
769 LINUX_GIT_DIR="${WORKSPACE}/src/linux"
770
771 LINUX_OBJ_DIR="${WORKSPACE}/linux"
772 LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
773 LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
774 LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
775
776 MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
777 MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
778
779 LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
780
781 OBJ_STORE_URL="s3://jenkins"
782
783 cd "$WORKSPACE"
784
785 # Create build directories
786 mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
787
788 git_clone_modules_sources
789
790 # Setup cross compile env if available
791 if [ "x${cross_arch}" != "x" ]; then
792
793 case "$cross_arch" in
794 "armhf")
795 karch="arm"
796 cross_compile="arm-linux-gnueabihf-"
797 vanilla_config="imx_v6_v7_defconfig"
798 ubuntu_config="armhf-config.flavour.generic"
799 ;;
800
801 "arm64")
802 karch="arm64"
803 cross_compile="aarch64-linux-gnu-"
804 vanilla_config="defconfig"
805 ubuntu_config="arm64-config.flavour.generic"
806 ;;
807
808 "powerpc")
809 karch="powerpc"
810 cross_compile="powerpc-linux-gnu-"
811 vanilla_config="ppc44x_defconfig"
812 ubuntu_config="powerpc-config.flavour.powerpc-smp"
813 ;;
814
815 "ppc64el")
816 karch="powerpc"
817 cross_compile="powerpc64le-linux-gnu-"
818 vanilla_config="pseries_le_defconfig"
819 ubuntu_config="ppc64el-config.flavour.generic"
820 ;;
821
822 *)
823 echo "Unsupported cross arch $cross_arch"
824 exit 1
825 ;;
826 esac
827
828 # Export variables used by Kbuild for cross compilation
829 export ARCH="${karch}"
830 export CROSS_COMPILE="${cross_compile}"
831
832 # Set arch specific values if we are not cross compiling
833 elif [ "x${arch}" != "x" ]; then
834
835 case "$arch" in
836 "i386")
837 karch="x86"
838 vanilla_config="allmodconfig"
839 ubuntu_config="i386-config.flavour.generic"
840 ;;
841
842 "amd64")
843 karch="x86"
844 vanilla_config="allmodconfig"
845 ubuntu_config="amd64-config.flavour.generic"
846 ;;
847
848 "armhf")
849 karch="arm"
850 vanilla_config="allmodconfig"
851 ubuntu_config="armhf-config.flavour.generic"
852 ;;
853
854 "arm64")
855 karch="arm64"
856 vanilla_config="allmodconfig"
857 ubuntu_config="arm64-config.flavour.generic"
858 ;;
859
860 "powerpc")
861 karch="powerpc"
862 vanilla_config="allmodconfig"
863 ubuntu_config="powerpc-config.flavour.powerpc-smp"
864 ;;
865
866 "ppc64el")
867 karch="powerpc"
868 vanilla_config="allmodconfig"
869 ubuntu_config="ppc64el-config.flavour.generic"
870 ;;
871
872 *)
873 echo "Unsupported arch $arch"
874 exit 1
875 ;;
876 esac
877 else
878 echo "No arch or cross_arch specified"
879 exit 1
880 fi
881
882
883
884 # First get the kernel build from the object store, or build it, if it's
885 # not available.
886
887 echo "# Setup endpoint
888 host_base = obj.internal.efficios.com
889 host_bucket = obj.internal.efficios.com
890 bucket_location = us-east-1
891 use_https = True
892
893 # Setup access keys
894 access_key = jenkins
895 secret_key = echo123456
896
897 # Enable S3 v4 signature APIs
898 signature_v2 = False" > "$WORKSPACE/.s3cfg"
899
900 url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
901 obj_name="linux.tar.bz2"
902
903 if [ "x${cross_arch}" = "x" ]; then
904 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/$arch/native"
905 else
906 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/${cross_arch}"
907 fi
908
909 obj_url="$obj_url_prefix/$obj_name"
910
911 set +e
912 # In s3cmd 2.3, the return code of get when an object does not exist (64)
913 # is different than in 2.2 (12). The return codes of 's3cmd info' are
914 # consistent between 2.2 and 2.3.
915 s3cmd -c "$WORKSPACE/.s3cfg" info "$obj_url"
916 ret=$?
917 set -e
918
919 case "$ret" in
920 "0")
921 s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
922 extract_archive_obj
923 ;;
924
925 "12")
926 echo "File not found"
927
928 # Build all the things and upload
929 # then finish the module build...
930
931 git_clone_linux_sources
932 git_export_linux_sources
933
934 select_compiler
935
936 ## PREPARE FULL LINUX SOURCE TREE
937 build_linux_kernel
938
939 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
940 extract_distro_headers
941
942 tar_archive_obj
943
944 upload_archive_obj
945
946 ;;
947
948 *)
949 echo "Unknown error? Abort"
950 exit 1
951 ;;
952 esac
953
954 select_compiler
955
956 selected_cc_version="$(echo "${selected_cc}" | cut -d'-' -f2)"
957 # lttng-modules requires gcc >= 5.1 for aarch64
958 # @see https://github.com/lttng/lttng-modules/commit/be06402dbdbea2f3394e60ec15c5d3356e2be416
959 if { verlt "${selected_cc_version}" "5.1"; } && [ "${cross_arch}" = "arm64" ] ; then
960 echo "Building lltng-modules on aarch64 requires gcc >= 5.1"
961 exit 0
962 fi
963
964 ## BUILD modules
965 # Either we downloaded a pre-build kernel or we built it and uploaded
966 # the archive for future builds.
967
968 cd "$WORKSPACE"
969
970 # Build modules against full kernel sources
971 build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
972
973 # Build modules against kernel headers
974 build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
975
976 # Make sure some modules were actually built
977 tree "${MODULES_OUTPUT_KSRC_DIR}"
978 if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
979 echo "No modules built!"
980 exit 1
981 fi
982
983 tree "${MODULES_OUTPUT_KHDR_DIR}"
984 if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
985 echo "No modules built!"
986 exit 1
987 fi
988
989 # EOF
This page took 0.050934 seconds and 5 git commands to generate.